#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include "dat.h"
#include <auth.h>
#include "fns.h"

enum{
	STACKSIZE=64*8064,  
};
char *dialstring;
char *eve;
char *spec;
int (*doconnect)(char*);
int netfd;
int srvfd;
int chatty;
int gen;
int ispipenet;
Attach *attachlist;
QLock thelock;
int domount;
int (*getkey)(char*);

char *logfile = "recover";

void
bell(void* p, char *msg)
{
//	fprint(2, "goodbye world %d: %s\n", getpid(), msg);
	if(strstr(msg, "write on closed pipe"))
		noted(NCONT);
	noted(NDFLT);
	USED(p);
}

char buf[100];
void
threadmain(int argc, char **argv)  
{
	char *srv;
	int pfd[2];
	char *p;
	fmtinstall('F', fcallfmt);
	fmtinstall('D', dirfmt);

	doconnect = connect9fs;
	netfd = -1;
	srvfd = -1;
	spec = nil;

	ARGBEGIN{
	case 'd':
		chatty++;
		break;
	case 's':
		ispipenet++;
		break;
	default:
		usage();
	}ARGEND;

	switch(argc){
	case 1:	/* calculate srv address */
		p = strrchr(argv[0], '/');
		p = p ? p+1 : argv[0];
		srv = smprint("%.28s", p);
		break;
	case 2:	/* calculate mtpt from address, srv given */
		srv = smprint("%.28s", argv[1]);
		break;
	case 3:
			/* calculate mtpt from address, srv given, spec given */
		srv = smprint("%.28s", argv[1]);
		spec = strdup(argv[2]);
		break;
	default:
		srv = nil;
		usage();
	}
	if(!ispipenet)
		dialstring = strdup(argv[0]);
	else
		dialstring = getdialstr(argv[0]);

	notify(bell);
	eve = getuser();

	if(!spec)
		spec=strdup("");
	attachment(spec);
	redial();

	if(pipe(pfd) < 0)
		sysfatal("pipe: %r");
	if(access(srv, 0) < 0)
		post9pservice(pfd[0], srv);
	close(pfd[0]);
	srvfd = pfd[1];
	
	proccreate(listennet, nil, STACKSIZE);
	proccreate(listensrv, nil, STACKSIZE);
	threadexits(nil);
}
